// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPUTemperature1 =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;
var snridCPUTemperature2 =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0210;

var snridVcoreVoltage =        (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0170;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0180;


var compRiser = new SysComponentInfo ('RISER', "parent.I18N['RISERBOARD']", 'info_riser.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI)
    )
);

var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_fan.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature2]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).unit]", snridCPUTemperature2)
    )
);

var compMemory;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value", 
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value)", snsridHasDMI)
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
        )
    );
}

var compCPU = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcoreVoltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature2]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).unit]", snridCPUTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcoreVoltage]", "parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).unit]", snridVcoreVoltage)
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2"),
        new triple ("parent.I18N['LPT_PORT']", "1")
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'",
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);


var theSystemComponents = new Tuple (
    compIOConnector,
    compMotherboard,
    compIPMI,
    compMemory,
    compRiser,
    compFan1,
    compCPU
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs100-e4_pi2/';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';
var imgPanelFront = 'main_front.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg'
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 71,  90,  87, 132), compIPMI),
            new AnArea (new Rect ( 84,  32,  95, 114), compRiser),
            new AnArea (new Rect (108,  43, 131, 124), compMemory),
            new AnArea (new Rect (139, 106, 173, 135), compCPU),
            new AnArea (new Rect (134, 156, 194, 211), compFan1),
            new AnArea (new Rect ( 58,  27, 194, 153), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_CPUFAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed, new Point (155, 175)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPUTemperature1, new Point (147, 112)),
            new quadruple ('AL_CPU1TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPUTemperature2, new Point (147, 112)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcoreVoltage, new Point (147, 112)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (133, 82)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (133, 82))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas ( 
            new AnArea (new Rect ( 82, 144, 184, 168), compIOConnector)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('f',
        "parent.I18N['USB_PORT']", "2"
    ),

    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2",
        "parent.I18N['LPT_PORT']", "1"
    )
);

